/*
 xGL:Camera.h
 Created by mantis on 14/07/05.
 Copyright 2005 xonko interactive. All rights reserved.
*/

#import <Cocoa/Cocoa.h>
#import "XGLNode.h"
#import "XGLLayer2D.h"
#import "XGLFogMachine.h"

@interface XGLCamera : XGLNode {

	NSSize bounds;
	float aspect;
	
	vector target;
	vector upHint;
	
	float fov;
	float near;
	float far;
	
	XGLNode *rootNode;
	
	NSMutableArray *backdrops;
	XGLFogMachine *fog;
	
	BOOL clearColorBuffer;
	NSColor *clearColor;
	
	BOOL wasReshaped;
	
}

//+(Class)class;

//-(id) init;
-(void)initGL;

- (XGLFogMachine *)fog;
- (void)setFog:(XGLFogMachine *)value;

-(void)reshapeWithSize:(NSSize)bound;

-(void)setupPerspective;

- (NSColor *)clearColor;
- (void)setClearColor:(NSColor *)value;

-(BOOL)clearColorBuffer;
-(void)setClearColorBuffer:(BOOL)newBool;

-(float)fov;
-(void)setFov:(float)newfov;

-(float)near;
-(void)setNear:(float)newnear;

-(float)far;
-(void)setFar:(float)newfar;

-(id)rootNode;
-(void)setRootNode:(id)newRootNode;

-(id)addBackdrop;
-(void)updateBackdrops;

-(void)renderScene;

@end
