/*
 *  vectorLib.h
 *  xGLCocoa
 *
 *  Created by mantis on 28/06/05.
 *  Copyright 2005 xonko interactive. All rights reserved.
 *
 */

#import <Carbon/Carbon.h>
#import <OpenGL/OpenGL.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>
#import <OpenGL/glext.h>


typedef struct {
	GLfloat x,y,z;
} vector;

int randomSign(void);
float randomFloat(void);
float randomRange( float min, float max);
void randomVector( vector *aVector, float min, float max );
void  vectorAddVector( vector *v1, vector *v2 );
void vectorSubtractVector( vector *v1, vector *v2 );
void vectorMultiplyByScalar( vector *v1, float scalar );
void vectorAddScalar( vector *v1, float scalar );
void vectorMadd( vector *v1, vector *v2, float scalar );
float vectorDot( vector *v1, vector *v2 );
vector vectorCross( vector *v1, vector *v2 );
float vectorMagnitude( vector *v1 );
vector vectorGetNormalised( vector *v1 );
void vectorNormalise( vector *v1 );
void vectorSetToVector(vector *v1, vector *v2);
